#ifndef _H_31880299E6366EE887FB8D1D2AE6E210_DistanceToDestination_DCPS_H_
#define _H_31880299E6366EE887FB8D1D2AE6E210_DistanceToDestination_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DistanceToDestination_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DistanceToDestination_TypeSupportInterface;

            typedef DistanceToDestination_TypeSupportInterface * DistanceToDestination_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DistanceToDestination_TypeSupportInterface> DistanceToDestination_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DistanceToDestination_TypeSupportInterface> DistanceToDestination_TypeSupportInterface_out;


            class DistanceToDestination_DataWriter;

            typedef DistanceToDestination_DataWriter * DistanceToDestination_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DistanceToDestination_DataWriter> DistanceToDestination_DataWriter_var;
            typedef DDS_DCPSInterface_out < DistanceToDestination_DataWriter> DistanceToDestination_DataWriter_out;


            class DistanceToDestination_DataReader;

            typedef DistanceToDestination_DataReader * DistanceToDestination_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DistanceToDestination_DataReader> DistanceToDestination_DataReader_var;
            typedef DDS_DCPSInterface_out < DistanceToDestination_DataReader> DistanceToDestination_DataReader_out;


            class DistanceToDestination_DataReaderView;

            typedef DistanceToDestination_DataReaderView * DistanceToDestination_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DistanceToDestination_DataReaderView> DistanceToDestination_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DistanceToDestination_DataReaderView> DistanceToDestination_DataReaderView_out;

            struct DistanceToDestination_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DistanceToDestination_, struct DistanceToDestination_Seq_uniq_> DistanceToDestination_Seq;
            typedef DDS_DCPSSequence_var < DistanceToDestination_Seq> DistanceToDestination_Seq_var;
            typedef DDS_DCPSSequence_out < DistanceToDestination_Seq> DistanceToDestination_Seq_out;

            class  DistanceToDestination_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DistanceToDestination_TypeSupportInterface_ptr _ptr_type;
                typedef DistanceToDestination_TypeSupportInterface_var _var_type;

                static DistanceToDestination_TypeSupportInterface_ptr _duplicate (DistanceToDestination_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceToDestination_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DistanceToDestination_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceToDestination_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceToDestination_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DistanceToDestination_TypeSupportInterface () {};
                ~DistanceToDestination_TypeSupportInterface () {};
            private:
                DistanceToDestination_TypeSupportInterface (const DistanceToDestination_TypeSupportInterface &);
                DistanceToDestination_TypeSupportInterface & operator = (const DistanceToDestination_TypeSupportInterface &);
            };

            class  DistanceToDestination_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DistanceToDestination_DataWriter_ptr _ptr_type;
                typedef DistanceToDestination_DataWriter_var _var_type;

                static DistanceToDestination_DataWriter_ptr _duplicate (DistanceToDestination_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceToDestination_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceToDestination_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DistanceToDestination_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DistanceToDestination_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DistanceToDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DistanceToDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DistanceToDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DistanceToDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DistanceToDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DistanceToDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DistanceToDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DistanceToDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DistanceToDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceToDestination_& instance_data) = 0;

            protected:
                DistanceToDestination_DataWriter () {};
                ~DistanceToDestination_DataWriter () {};
            private:
                DistanceToDestination_DataWriter (const DistanceToDestination_DataWriter &);
                DistanceToDestination_DataWriter & operator = (const DistanceToDestination_DataWriter &);
            };

            class  DistanceToDestination_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DistanceToDestination_DataReader_ptr _ptr_type;
                typedef DistanceToDestination_DataReader_var _var_type;

                static DistanceToDestination_DataReader_ptr _duplicate (DistanceToDestination_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceToDestination_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceToDestination_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DistanceToDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DistanceToDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DistanceToDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceToDestination_& instance) = 0;

            protected:
                DistanceToDestination_DataReader () {};
                ~DistanceToDestination_DataReader () {};
            private:
                DistanceToDestination_DataReader (const DistanceToDestination_DataReader &);
                DistanceToDestination_DataReader & operator = (const DistanceToDestination_DataReader &);
            };

            class  DistanceToDestination_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DistanceToDestination_DataReaderView_ptr _ptr_type;
                typedef DistanceToDestination_DataReaderView_var _var_type;

                static DistanceToDestination_DataReaderView_ptr _duplicate (DistanceToDestination_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DistanceToDestination_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DistanceToDestination_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DistanceToDestination_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DistanceToDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DistanceToDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DistanceToDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DistanceToDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DistanceToDestination_& instance) = 0;

            protected:
                DistanceToDestination_DataReaderView () {};
                ~DistanceToDestination_DataReaderView () {};
            private:
                DistanceToDestination_DataReaderView (const DistanceToDestination_DataReaderView &);
                DistanceToDestination_DataReaderView & operator = (const DistanceToDestination_DataReaderView &);
            };
        }

    }

}

#endif
