#ifndef _H_CA5CD3AD9920DDDE3A67896B1F5EB2F4_LaneBoundaryArray_DCPS_H_
#define _H_CA5CD3AD9920DDDE3A67896B1F5EB2F4_LaneBoundaryArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LaneBoundaryArray_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LaneBoundaryArray_TypeSupportInterface;

            typedef LaneBoundaryArray_TypeSupportInterface * LaneBoundaryArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundaryArray_TypeSupportInterface> LaneBoundaryArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LaneBoundaryArray_TypeSupportInterface> LaneBoundaryArray_TypeSupportInterface_out;


            class LaneBoundaryArray_DataWriter;

            typedef LaneBoundaryArray_DataWriter * LaneBoundaryArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundaryArray_DataWriter> LaneBoundaryArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < LaneBoundaryArray_DataWriter> LaneBoundaryArray_DataWriter_out;


            class LaneBoundaryArray_DataReader;

            typedef LaneBoundaryArray_DataReader * LaneBoundaryArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundaryArray_DataReader> LaneBoundaryArray_DataReader_var;
            typedef DDS_DCPSInterface_out < LaneBoundaryArray_DataReader> LaneBoundaryArray_DataReader_out;


            class LaneBoundaryArray_DataReaderView;

            typedef LaneBoundaryArray_DataReaderView * LaneBoundaryArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LaneBoundaryArray_DataReaderView> LaneBoundaryArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LaneBoundaryArray_DataReaderView> LaneBoundaryArray_DataReaderView_out;

            struct LaneBoundaryArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LaneBoundaryArray_, struct LaneBoundaryArray_Seq_uniq_> LaneBoundaryArray_Seq;
            typedef DDS_DCPSSequence_var < LaneBoundaryArray_Seq> LaneBoundaryArray_Seq_var;
            typedef DDS_DCPSSequence_out < LaneBoundaryArray_Seq> LaneBoundaryArray_Seq_out;

            class  LaneBoundaryArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LaneBoundaryArray_TypeSupportInterface_ptr _ptr_type;
                typedef LaneBoundaryArray_TypeSupportInterface_var _var_type;

                static LaneBoundaryArray_TypeSupportInterface_ptr _duplicate (LaneBoundaryArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundaryArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundaryArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LaneBoundaryArray_TypeSupportInterface () {};
                ~LaneBoundaryArray_TypeSupportInterface () {};
            private:
                LaneBoundaryArray_TypeSupportInterface (const LaneBoundaryArray_TypeSupportInterface &);
                LaneBoundaryArray_TypeSupportInterface & operator = (const LaneBoundaryArray_TypeSupportInterface &);
            };

            class  LaneBoundaryArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LaneBoundaryArray_DataWriter_ptr _ptr_type;
                typedef LaneBoundaryArray_DataWriter_var _var_type;

                static LaneBoundaryArray_DataWriter_ptr _duplicate (LaneBoundaryArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundaryArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundaryArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LaneBoundaryArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LaneBoundaryArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LaneBoundaryArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LaneBoundaryArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LaneBoundaryArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LaneBoundaryArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LaneBoundaryArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LaneBoundaryArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LaneBoundaryArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LaneBoundaryArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LaneBoundaryArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundaryArray_& instance_data) = 0;

            protected:
                LaneBoundaryArray_DataWriter () {};
                ~LaneBoundaryArray_DataWriter () {};
            private:
                LaneBoundaryArray_DataWriter (const LaneBoundaryArray_DataWriter &);
                LaneBoundaryArray_DataWriter & operator = (const LaneBoundaryArray_DataWriter &);
            };

            class  LaneBoundaryArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LaneBoundaryArray_DataReader_ptr _ptr_type;
                typedef LaneBoundaryArray_DataReader_var _var_type;

                static LaneBoundaryArray_DataReader_ptr _duplicate (LaneBoundaryArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundaryArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundaryArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneBoundaryArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneBoundaryArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneBoundaryArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundaryArray_& instance) = 0;

            protected:
                LaneBoundaryArray_DataReader () {};
                ~LaneBoundaryArray_DataReader () {};
            private:
                LaneBoundaryArray_DataReader (const LaneBoundaryArray_DataReader &);
                LaneBoundaryArray_DataReader & operator = (const LaneBoundaryArray_DataReader &);
            };

            class  LaneBoundaryArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LaneBoundaryArray_DataReaderView_ptr _ptr_type;
                typedef LaneBoundaryArray_DataReaderView_var _var_type;

                static LaneBoundaryArray_DataReaderView_ptr _duplicate (LaneBoundaryArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneBoundaryArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneBoundaryArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneBoundaryArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneBoundaryArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneBoundaryArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneBoundaryArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneBoundaryArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneBoundaryArray_& instance) = 0;

            protected:
                LaneBoundaryArray_DataReaderView () {};
                ~LaneBoundaryArray_DataReaderView () {};
            private:
                LaneBoundaryArray_DataReaderView (const LaneBoundaryArray_DataReaderView &);
                LaneBoundaryArray_DataReaderView & operator = (const LaneBoundaryArray_DataReaderView &);
            };
        }

    }

}

#endif
