#ifndef _H_0E332DC14C06A8B4ED00D124CEDF6EA1_LaneBoundary__H_
#define _H_0E332DC14C06A8B4ED00D124CEDF6EA1_LaneBoundary__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace LaneBoundary_Constants
            {
                const ::DDS::Octet UNKNOWN_ = 0;

                const ::DDS::Octet SOLID_ = 1;

                const ::DDS::Octet DASHED_ = 2;

                const ::DDS::Octet SOLID_DASHED_ = 3;

                const ::DDS::Octet DASHED_SOLID_ = 4;

                const ::DDS::Octet SOLID_SOLID_ = 5;

                const ::DDS::Octet WHITE_ = 1;

                const ::DDS::Octet YELLOW_ = 2;

            }

            struct  LaneBoundary_
            {
                struct _line__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::geometry_msgs::msg::dds_::Point_, struct _line__seq_uniq_ > _line__seq;
                typedef DDS_DCPSSequence_var< _line__seq > _line__seq_var;
                typedef DDS_DCPSSequence_out< _line__seq > _line__seq_out;
                ::DDS::Octet style_;
                ::DDS::Octet color_;
                _line__seq line_;
            };

            typedef DDS_DCPSStruct_var<LaneBoundary_> LaneBoundary__var;
            typedef DDS_DCPSStruct_out < LaneBoundary_> LaneBoundary__out;

        }

    }

}

#endif /* _H_0E332DC14C06A8B4ED00D124CEDF6EA1_LaneBoundary__H_ */
