// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from automotive_navigation_msgs:msg/PointOfInterestRequest.idl
// generated code does not contain a copyright notice
#include "automotive_navigation_msgs/msg/point_of_interest_request__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `name`
// Member `module_name`
#include "rosidl_generator_c/string_functions.h"

bool
automotive_navigation_msgs__msg__PointOfInterestRequest__init(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // name
  if (!rosidl_generator_c__String__init(&msg->name)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // module_name
  if (!rosidl_generator_c__String__init(&msg->module_name)) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
    return false;
  }
  // request_id
  // cancel
  // update_num
  // guid_valid
  // guid
  // tolerance
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__fini(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_generator_c__String__fini(&msg->name);
  // module_name
  rosidl_generator_c__String__fini(&msg->module_name);
  // request_id
  // cancel
  // update_num
  // guid_valid
  // guid
  // tolerance
}

automotive_navigation_msgs__msg__PointOfInterestRequest *
automotive_navigation_msgs__msg__PointOfInterestRequest__create()
{
  automotive_navigation_msgs__msg__PointOfInterestRequest * msg = (automotive_navigation_msgs__msg__PointOfInterestRequest *)malloc(sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest));
  bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__destroy(automotive_navigation_msgs__msg__PointOfInterestRequest * msg)
{
  if (msg) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__fini(msg);
  }
  free(msg);
}


bool
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__init(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  automotive_navigation_msgs__msg__PointOfInterestRequest * data = NULL;
  if (size) {
    data = (automotive_navigation_msgs__msg__PointOfInterestRequest *)calloc(size, sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        automotive_navigation_msgs__msg__PointOfInterestRequest__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__fini(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      automotive_navigation_msgs__msg__PointOfInterestRequest__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence *
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__create(size_t size)
{
  automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array = (automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence *)malloc(sizeof(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__destroy(automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence * array)
{
  if (array) {
    automotive_navigation_msgs__msg__PointOfInterestRequest__Sequence__fini(array);
  }
  free(array);
}
