#ifndef _H_776785B2093A5D9BD54D531835962ECF_DesiredDestination_DCPS_H_
#define _H_776785B2093A5D9BD54D531835962ECF_DesiredDestination_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DesiredDestination_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DesiredDestination_TypeSupportInterface;

            typedef DesiredDestination_TypeSupportInterface * DesiredDestination_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DesiredDestination_TypeSupportInterface> DesiredDestination_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DesiredDestination_TypeSupportInterface> DesiredDestination_TypeSupportInterface_out;


            class DesiredDestination_DataWriter;

            typedef DesiredDestination_DataWriter * DesiredDestination_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DesiredDestination_DataWriter> DesiredDestination_DataWriter_var;
            typedef DDS_DCPSInterface_out < DesiredDestination_DataWriter> DesiredDestination_DataWriter_out;


            class DesiredDestination_DataReader;

            typedef DesiredDestination_DataReader * DesiredDestination_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DesiredDestination_DataReader> DesiredDestination_DataReader_var;
            typedef DDS_DCPSInterface_out < DesiredDestination_DataReader> DesiredDestination_DataReader_out;


            class DesiredDestination_DataReaderView;

            typedef DesiredDestination_DataReaderView * DesiredDestination_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DesiredDestination_DataReaderView> DesiredDestination_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DesiredDestination_DataReaderView> DesiredDestination_DataReaderView_out;

            struct DesiredDestination_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DesiredDestination_, struct DesiredDestination_Seq_uniq_> DesiredDestination_Seq;
            typedef DDS_DCPSSequence_var < DesiredDestination_Seq> DesiredDestination_Seq_var;
            typedef DDS_DCPSSequence_out < DesiredDestination_Seq> DesiredDestination_Seq_out;

            class  DesiredDestination_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DesiredDestination_TypeSupportInterface_ptr _ptr_type;
                typedef DesiredDestination_TypeSupportInterface_var _var_type;

                static DesiredDestination_TypeSupportInterface_ptr _duplicate (DesiredDestination_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DesiredDestination_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DesiredDestination_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DesiredDestination_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DesiredDestination_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DesiredDestination_TypeSupportInterface () {};
                ~DesiredDestination_TypeSupportInterface () {};
            private:
                DesiredDestination_TypeSupportInterface (const DesiredDestination_TypeSupportInterface &);
                DesiredDestination_TypeSupportInterface & operator = (const DesiredDestination_TypeSupportInterface &);
            };

            class  DesiredDestination_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DesiredDestination_DataWriter_ptr _ptr_type;
                typedef DesiredDestination_DataWriter_var _var_type;

                static DesiredDestination_DataWriter_ptr _duplicate (DesiredDestination_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DesiredDestination_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DesiredDestination_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DesiredDestination_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DesiredDestination_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DesiredDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DesiredDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DesiredDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DesiredDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DesiredDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DesiredDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DesiredDestination_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DesiredDestination_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DesiredDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DesiredDestination_& instance_data) = 0;

            protected:
                DesiredDestination_DataWriter () {};
                ~DesiredDestination_DataWriter () {};
            private:
                DesiredDestination_DataWriter (const DesiredDestination_DataWriter &);
                DesiredDestination_DataWriter & operator = (const DesiredDestination_DataWriter &);
            };

            class  DesiredDestination_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DesiredDestination_DataReader_ptr _ptr_type;
                typedef DesiredDestination_DataReader_var _var_type;

                static DesiredDestination_DataReader_ptr _duplicate (DesiredDestination_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DesiredDestination_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DesiredDestination_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DesiredDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DesiredDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DesiredDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DesiredDestination_& instance) = 0;

            protected:
                DesiredDestination_DataReader () {};
                ~DesiredDestination_DataReader () {};
            private:
                DesiredDestination_DataReader (const DesiredDestination_DataReader &);
                DesiredDestination_DataReader & operator = (const DesiredDestination_DataReader &);
            };

            class  DesiredDestination_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DesiredDestination_DataReaderView_ptr _ptr_type;
                typedef DesiredDestination_DataReaderView_var _var_type;

                static DesiredDestination_DataReaderView_ptr _duplicate (DesiredDestination_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DesiredDestination_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DesiredDestination_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DesiredDestination_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DesiredDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DesiredDestination_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DesiredDestination_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DesiredDestination_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DesiredDestination_& instance) = 0;

            protected:
                DesiredDestination_DataReaderView () {};
                ~DesiredDestination_DataReaderView () {};
            private:
                DesiredDestination_DataReaderView (const DesiredDestination_DataReaderView &);
                DesiredDestination_DataReaderView & operator = (const DesiredDestination_DataReaderView &);
            };
        }

    }

}

#endif
