#ifndef _H_CCF6A34DBE60D36CFC94FEC0790D2B6B_Direction__H_
#define _H_CCF6A34DBE60D36CFC94FEC0790D2B6B_Direction__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace automotive_navigation_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Direction_Constants
            {
                const ::DDS::Octet BACKWARD_ = 255;

                const ::DDS::Octet ZERO_ = 0;

                const ::DDS::Octet FORWARD_ = 1;

            }

            struct  Direction_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet direction_;
            };

            typedef DDS_DCPSStruct_var<Direction_> Direction__var;
            typedef DDS_DCPSStruct_out < Direction_> Direction__out;

        }

    }

}

#endif /* _H_CCF6A34DBE60D36CFC94FEC0790D2B6B_Direction__H_ */
