// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterest.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST__STRUCT_HPP_
#define AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterest __attribute__((deprecated))
#else
# define DEPRECATED__automotive_navigation_msgs__msg__PointOfInterest __declspec(deprecated)
#endif

namespace automotive_navigation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PointOfInterest_
{
  using Type = PointOfInterest_<ContainerAllocator>;

  explicit PointOfInterest_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->guid = 0ull;
      this->latitude = 0.0;
      this->longitude = 0.0;
      this->params = "";
    }
  }

  explicit PointOfInterest_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : params(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->guid = 0ull;
      this->latitude = 0.0;
      this->longitude = 0.0;
      this->params = "";
    }
  }

  // field types and members
  using _guid_type =
    uint64_t;
  _guid_type guid;
  using _latitude_type =
    double;
  _latitude_type latitude;
  using _longitude_type =
    double;
  _longitude_type longitude;
  using _params_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _params_type params;

  // setters for named parameter idiom
  Type & set__guid(
    const uint64_t & _arg)
  {
    this->guid = _arg;
    return *this;
  }
  Type & set__latitude(
    const double & _arg)
  {
    this->latitude = _arg;
    return *this;
  }
  Type & set__longitude(
    const double & _arg)
  {
    this->longitude = _arg;
    return *this;
  }
  Type & set__params(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->params = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> *;
  using ConstRawPtr =
    const automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterest
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__automotive_navigation_msgs__msg__PointOfInterest
    std::shared_ptr<automotive_navigation_msgs::msg::PointOfInterest_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PointOfInterest_ & other) const
  {
    if (this->guid != other.guid) {
      return false;
    }
    if (this->latitude != other.latitude) {
      return false;
    }
    if (this->longitude != other.longitude) {
      return false;
    }
    if (this->params != other.params) {
      return false;
    }
    return true;
  }
  bool operator!=(const PointOfInterest_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PointOfInterest_

// alias to use template instance with default allocator
using PointOfInterest =
  automotive_navigation_msgs::msg::PointOfInterest_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace automotive_navigation_msgs

#endif  // AUTOMOTIVE_NAVIGATION_MSGS__MSG__POINT_OF_INTEREST__STRUCT_HPP_
