// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from automotive_navigation_msgs:msg/PointOfInterestArray.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_generator_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "automotive_navigation_msgs/msg/point_of_interest_array__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace automotive_navigation_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void PointOfInterestArray_init_function(
  void * message_memory, rosidl_generator_cpp::MessageInitialization _init)
{
  new (message_memory) automotive_navigation_msgs::msg::PointOfInterestArray(_init);
}

void PointOfInterestArray_fini_function(void * message_memory)
{
  auto typed_message = static_cast<automotive_navigation_msgs::msg::PointOfInterestArray *>(message_memory);
  typed_message->~PointOfInterestArray();
}

size_t size_function__PointOfInterestArray__point_list(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<automotive_navigation_msgs::msg::PointOfInterest> *>(untyped_member);
  return member->size();
}

const void * get_const_function__PointOfInterestArray__point_list(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<automotive_navigation_msgs::msg::PointOfInterest> *>(untyped_member);
  return &member[index];
}

void * get_function__PointOfInterestArray__point_list(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<automotive_navigation_msgs::msg::PointOfInterest> *>(untyped_member);
  return &member[index];
}

void resize_function__PointOfInterestArray__point_list(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<automotive_navigation_msgs::msg::PointOfInterest> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember PointOfInterestArray_message_member_array[3] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterestArray, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "update_num",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_UINT16,  // type
    0,  // upper bound of string
    nullptr,  // members of sub message
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterestArray, update_num),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "point_list",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<automotive_navigation_msgs::msg::PointOfInterest>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(automotive_navigation_msgs::msg::PointOfInterestArray, point_list),  // bytes offset in struct
    nullptr,  // default value
    size_function__PointOfInterestArray__point_list,  // size() function pointer
    get_const_function__PointOfInterestArray__point_list,  // get_const(index) function pointer
    get_function__PointOfInterestArray__point_list,  // get(index) function pointer
    resize_function__PointOfInterestArray__point_list  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers PointOfInterestArray_message_members = {
  "automotive_navigation_msgs::msg",  // message namespace
  "PointOfInterestArray",  // message name
  3,  // number of fields
  sizeof(automotive_navigation_msgs::msg::PointOfInterestArray),
  PointOfInterestArray_message_member_array,  // message members
  PointOfInterestArray_init_function,  // function to initialize message memory (memory has to be allocated)
  PointOfInterestArray_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t PointOfInterestArray_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &PointOfInterestArray_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace automotive_navigation_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<automotive_navigation_msgs::msg::PointOfInterestArray>()
{
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::PointOfInterestArray_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, automotive_navigation_msgs, msg, PointOfInterestArray)() {
  return &::automotive_navigation_msgs::msg::rosidl_typesupport_introspection_cpp::PointOfInterestArray_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
